//Meta data
var MetaData_version = 1;  //maybe used by tools.html

var _study = {
  note      : [],
  Add       : function(bkIdx, Ch, Vs, title, text, video, youtube) {
    this.bkIdx = bkIdx; // 0 based - bible book
    this.chapter = Ch;  // 1 based 
    this.verse = Vs;    // 1 based
    this.title = title;
    this.text = text;
    this.video = video;
    this.youtube = youtube;
  },
  Match     : function(bkIdx, Ch, Vs) { // ch,vc (1 based, <= match any); returns array of matches (or empty array)
    var i, ret = [], bkMatch = false, chMatch = false, vsMatch = false; 
    for (i=0; i < this.note.length ;i++) 
    {
      if (this.note[i].bkIdx === bkIdx) { 
        bkMatch = true; 
        if (this.note[i].chapter === Ch || Ch <= 0) {
          chMatch = true;
          if (this.note[i].verse === Vs || Vs <= 0) {
            vsMatch = true;
            ret.push(i);
          }
          else if (vsMatch) // no longer in verse of interest
            break;
        }
        else if (chMatch) // no longer in chapter of interest
          break;
      }
      else if (bkMatch) // no longer in book of interest
        break;  
    }
    return ret;
  },
  FillNotes : function() {
   var text = ["To fully understand a bible translation, we need to go back to the original Hebrew and Greek text."];
   text.push("For example, the English word \"God\" is used to represent several Hebrew words.");
   text.push("Strongs manifests the full meaning. In Genesis 1, God(H430) \"Elohim\" made heaven and earth, and the original man(H120) (serpent race).");
   text.push("In Genesis 2 the \"Lord(H3068) God(H410)\" made the first spiritual man Adam(H121). What follows is a mixed race.<br>This video by Jonathan Kleck explains it well: ");
   this.note.push(new _study.Add(0,1,1, 
             "Elohim (gods of the Supreme God) created the earth?", 
             text.join(" "), 
             "161204-03|The ((LORD GOD)) created Adam,((Elohyim created an idol)).",
             "uBhZEexiLBY")); //https://youtu.be/uBhZEexiLBY
  
   var text = ["Jonathan takes us through the basics. We are born upside down into a world of deception."];
   this.note.push(new _study.Add(22,14,1, //Isaiah
             "(They) turn things upside down. Who are they?", 
             text.join(" "), 
             "210124-P07|Part1-KNOW the SCRIPTURES (with captions) - by Jonathan Kleck.",
             "E-zTPIvWO0Q")); 
    
   var text = ["Lucifer (the Dragon) was the leader of the rebellion in heaven (aka the Serpent/Satan/Devil - Rev 12)."];
   text.push("He was called the light-bearer as he took God's angels (the shiney ones) captive.");
   this.note.push(new _study.Add(22,14,12, //Isaiah
             "Why is Lucifer known as the light-bearer?", 
             text.join(" "), 
             "190709-P01|Know Your Enemy END TIME Message by Jonathan Kleck.",
             "LC9v5nAhcrI")); 
    
  },
  GetNote   : function(bk,ch,vs) {
    var nn = this.Match(bk,ch,vs);
    if (nn.length !== 0) 
       return MakeStudyBox(nn[0], false); 
    return [];
  }
}
_study.FillNotes();

var _StudyNotesBG = null;
var _StudyNotesBx = null;
function CloseStudyBG(event) {
  CloseStudyNotesList();
}
function CloseStudyNotesList() {
  if (_StudyNotesBG !== null && _StudyNotesBG.style.display !== "none") {
     EnableMainScroll(true); 
     _StudyNotesBG.style.display = "none";
  }
}
function ShowStudyNotesIndex(event) {
  event.stopPropagation();
  
  if (_StudyNotesBG === null) {
    _StudyNotesBG = document.getElementById("StudyNotesBG");
    _StudyNotesBx = document.getElementById("StudyNotesBx");
    
    // Add all Notes panels
    var n, html = [''];
    html.push('<div onclick="CloseStudyBG(event)" style="padding:8px 8px 15px 8px;cursor:pointer;">◁&nbsp;back</div>');
    for (n = 0; n < _study.note.length; n++) {
      var note = MakeStudyBox(n, true);
      if (note.length != 0)
        html.push(note.join(" "));
    }
    _StudyNotesBx.innerHTML = html.join(" ");
  }
    
  // Set Default for Transition IN
  //
  
  _StudyNotesBG.style.transitionDuration="0s";
  _StudyNotesBG.style.opacity = "0";
  
  _StudyNotesBx.style.transitionDuration="0s";
  _StudyNotesBx.style.height = "0px";
  _StudyNotesBx.style.opacity = "0";
  
  // Postion and Transition IN
  
  EnableMainScroll(false);
  var xtop = window.pageYOffset || document.documentElement.scrollTop;
  _StudyNotesBG.style.top = xtop + "px";
  _StudyNotesBG.style.display = "block";
  _StudyNotesBx.focus();
  
  // Trans IN

  _StudyNotesBG.style.transitionDuration=".2s";
  _StudyNotesBG.style.opacity = "1.0";
  _StudyNotesBx.style.transitionDuration=".5s";
  _StudyNotesBx.style.transitionDelay = "200ms";
  
  _StudyNotesBx.style.height = "100%";
  _StudyNotesBx.style.opacity = "1.0";
}
function StudyNotePanelClick(event) {  // stop the list from disappearing on click
   event.stopPropagation();
}
function ListStudyNotesClickThru(event, n) {
  event.stopPropagation();
  CloseStudyNotesList();
  
  var bkIdx = _study.note[n].bkIdx;
  var ch = _study.note[n].chapter;
  var vs = _study.note[n].verse;
  
  var bcv = kjvObj.book[bkIdx].name + " " + ch + ":" + vs;
  LoadBkChVs(bcv);
  //alert("click through");
}
function ExpandStudyNote(nIdx) {
  el = document.getElementById("snote_"+nIdx);
  if (el) {
    if (el.style.display === "none") 
      el.style.display = "block";
      else el.style.display = "none";
  }
}
function MakeStudyBox(noteIdx, inListDisplay) {
  
  var html = [];
  var n = noteIdx;
  var note = _study.note[noteIdx];
  var bkAdr = kjvObj.book[note.bkIdx].name3 + "&nbsp;" + note.chapter + ":" + note.verse;
  
  var vidName = note.video.split("|"); // "161204-03|The ((LORD GOD)) created Adam,((Elohyim created an idol))."
  var youtubeLink = "https://youtu.be/" + note.youtube;
  var altLink = "index.html?"+ vidName[0];  //just ID '161204-03'
  
  if (inListDisplay) // click here is just to block
    html.push('<div onclick="StudyNotePanelClick(event)" class="StudyPane_Shadow">');
  else 
    html.push('<div onclick="StudyNotePanelClick(event)" class="StudyPane">');

   if (inListDisplay)
     html.push('<div>');
   else 
     html.push('<div onclick="ExpandStudyNote(\''+n+'\')" style="cursor:pointer;">');
  
     if (inListDisplay)
       html.push('<span onclick="ListStudyNotesClickThru(event, '+n+')" class="StudyPaneIcon" style="margin-top:1px;">'+bkAdr+'&nbsp;▶</span>');
     else 
       html.push('<span onclick="ShowStudyNotesIndex(event)" class="StudyPaneIcon">☰</span>');
     //html.push("📝Study&nbsp;note:&nbsp;" + note.title);
     html.push("📝&nbsp;" + note.title);
   html.push('</div>');
  
   if (inListDisplay) //Expanded note
     html.push('<div style="display:block;padding:9px 4px 4px 2px;">');
   else
     html.push('<div id="snote_'+n+'" style="display:none;padding:9px 4px 4px 2px;">');
   html.push(note.text);
   html.push('<p style="margin-top:8px;margin-bottom:4px;">');
   html.push('🎬&nbsp;"' + vidName[1] + "&nbsp;"); //title
   html.push(' |&nbsp;<a href="'+youtubeLink+'" target="_blank">Youtube link</a> |&nbsp;<a href="'+altLink+'" target="_blank">Kleck Files link</a>');
   html.push('</p>');
   html.push('</div>');
  html.push('</div>');
  return html;
}




var _md = {

  ChHdr    : "ChHdr",           // checkbox: Show Header Checkbox - _metadata.settings[_md.ChHdr].checked 
  TopicHdr : "TopicHdr",        // checkbox = Topic headings
  Markup   : "Markup",          // checkbox = KJV text subs and markup
  ParaOn   : "ParaOn"          // checkbox = No Paragraphs

  
  
}

var _metadata = {
  ChangeCallback : null,
  settings       : {},            // eg. _metadata.settings[_md.ChHdr].checked
  debugMode      : false,         // manually set true/false 
  
  // persistent Get/Set funcs
  //
  StrongsVisible : function(fValue) {
     if (typeof fValue == "undefined")
       return Store_GetBool("StrongsVisible", true);
     else 
       Store_SetBool("StrongsVisible", fValue);
  }
  
};  


//
// Controls
//
function MakeCheckBox(parent, id, checked, text, callback) {
  if (typeof parent == "string") //an id was sent - we want the obj
    this.parentO = document.getElementById(parent);
    else this.parentO = parent;
  this.text = text;
  this.id = id;
  
  if (typeof callback !== "undefined" && callback !== null)
    _metadata.ChangeCallback = callback;

  var x1 = document.createElement("INPUT");
  var x2 = document.createElement("LABEL");
  
  x1.setAttribute("type", "checkbox");
  x1.setAttribute("id", "checkbox_"+id);
  x1.setAttribute("onclick", '_metadata.ChangeCallback("'+id+'")');
  x1.checked = Store_GetBool(id, checked);   //use stored value (defalt passed value)  
  x2.setAttribute("for", "checkbox_"+id);
  x2.innerHTML = "&nbsp;" + text;
  
  var div = document.createElement("div");
  div.setAttribute("style", "padding: 3px 4px;");
  this.parentO.appendChild(div); 

  div.appendChild(x1);   
  div.appendChild(x2);
  
  // checkbox control added to named aray indexed on ID oe _md.id 
  // eg. _metadata.settings[id].checked 
  // eg. _metadata.settings[_md.ChHdr].checked
  //
  _metadata.settings[id] = x1;  //x1.checked  -- checkboc into settings 
  
}



//
// Permanent Storage 
//
function Store_GetValue(name, defaultValue) {  // strings
  try {
     if (window.localStorage) {
        var value = window.localStorage.getItem("KF_"+name);
        if (value) 
           return value;  
     }
  } catch(err) {}
  return defaultValue;
}
function Store_SetValue(name, value) {  // strings
  try {
     if (window.localStorage) {
        window.localStorage.setItem("KF_"+name, value);  
     }
  } catch(err) {}
}
function Store_GetBool(name, defBoolean) {
  return Store_GetValue(name, defBoolean.toString()) == "true";
}
function Store_SetBool(name, boolValue) {
  Store_SetValue(name, boolValue.toString());
}

///
/// Chapter Paragraphs 
/// - These are 1 based Verse numbers -- where Paragraphs start. 
/// - Note: Verse 1 is ommitted but assumed since 1 is always a paragraph start.
/// - Use 0 = fill with single verses (until a verse number) eg. [0] all single.
///   or [0,28] (v1-v27,v28-end), or [3,0,9] (parags = v1-v2, v3-v8 (singles), v9-end )
/// - Use [1] to mean chapter is one big single paragraph (only time 1 is ever used here)
/// - -1 is like 0 but forms a line break (starts on new line with no vertical space)

var _paragraphs = [ 
[ //Genesis - 50 ch
  [6,9,14,20,24,26,29],[4,8,18],[8,22],[16,19,25],[3,6,9,12,15,18,21,25,28],
  [5,9],[7,11,17],[6,13,15,20],[8,18,20,28],[6,15,21,32],
  [10,27],[6,10],[5,14],[13,17],[1], // single para ch 
  [7],[9,15,23],[9,16,23],[4,12,15,17,23,26,29,30],[17],
  [6,9,14,22,33],[3,15,20],[3,17],[10,22,28,32,50,61,62],[7,11,12,19,24,29],
  [6,12,17,23,26,34],[5,18,30,41,46],[6,10],[9,15,21,31],[9,14,22,25,37],
  [17,22,36,43],[6,9,13,24],[16,18],[6,20,25],[6,9,16,21,27],
  [9,14,15,17,18,20,31,40],[5,9,12,15,23,29],[12,24,27],[7,21],[5,16,20],
  [9,14,25,37,46,50,53],[5,21,25,29,35],[15,26],[6,14,18],[16,25],
  [8,10,0,17,19,20,21,23,24,26,28],[11,13,27],[8,15],[0,28],[4,7,14,15,22]
],
[//Exodus - 40
  [7,8,15],[5,11,15,23],[7,11],[6,10,18,24,27,29],[6,10,15,20],  
  [2,10,14,16,28],[8,10,14,19],[5,8,16,20,25,30],[8,13,22,27],[12,16,21,24,27],  
  [4,9],[3,11,18,21,29,31,37,40,43,50],[3,5,8,11,14,17,20],[5,10,15,19,23,26],[0,19,20,22,27],  
  [4,9,11,22,27,32],[8],[13,27],[7,10,14,16],[3,4,7,8,12,0,22],
  [2,7,12,15,0,18,20,22,26,28,33,35],[2,5,6,7,10,14,16,18,0,22,25,28,29,31],[0,4,6,8,9,10,14,17,18,20,26],[3,9,12],[10,23,31],  
  [7,15,26,31],[9,16,18,20],[6,13,22,26,30,33,36,39,40],[15,19,29,31,35,38],[11,17,22,34],  
  [12,18],[7,15,19,25,30],[4,7,12],[4,10,17,18,19,21,22,23,25,26,27,29],[4,20,30],  
  [5,8,9,14,15,20,31,35,37],[6,10,17,25,29],[8,9,21,24],[6,8,22,27,30,32,33],[17,20,22,24,26,28,30,34]  
],
[//Leviticus - 27
  [3,10,14],[4,5,6,7,12],[6,12],[13,22,27],[11,14,17],  
  [8,14,19,24],[11,22,28,35],[6,14,18,22,31],[5,8,15,22],[8,12,16],  
  [9,13,24,29,39,41],[1],[9,18,24,29,38,40,43,45,47,48,49],[21,22,54],[13,16,19,31],  
  [15,20,23,29],[8,10],[6,24],[3,0,5,9,11,0,20,23,26,29,30,31,32,33,35],[6,7,9,10,22,27],  
  [9,10,16],[10,14,17,26],[4,9,15,22,23,26,33,39],[5,10,17,23],[8,18,23,25,29,35,39,47],  
  [2,3,14,21,27],[9,14,16,26,30,34]  
],
[//Numbers - 36
  [5,17,20,22,24,26,28,30,32,34,38,40,42,44,47],[10,17,18,25,29,32],[5,11,14,21,27,33,38,39,40,44],[5,16,17,21,29,34,42,46],[5,11,29],  
  [13,22],[10,12,18,24,30,36,42,48,54,60,66,72,78,84,89],[5,23],[6,9,15],[11,14,18,22,25,29,33],  
  [4,10,16,24,31],[1],[17,21,26],[6,11,13,19,20,26,40],[17,22,27,30,32,37],  
  [12,20,31,36,41],[6,10],[8,20,25],[11],[7,12,14,22],  
  [4,10,17,21,27,0,33],[15,22,36],[7,0,11,14,18,0,25,27],[3,0,10,15,0],[6,10,16],  
  [5,12,15,19,23,26,28,33,35,38,42,44,48,51,52,57,63],[6,12,15,18],[9,11,16,26],[7,12,17,20,23,26,29,32,35],[1],  
  [13,21,25,48],[6,16,20,34],[50],[13,16],[9,30],  
  [1] 
],
[//Deuteronomy -34
  [9,19],[16,26],[18,21],[14,25,41,44],[7,8,11,12,16,0,22],  
  [4,10,16],[12],[1],[7],[6,8,12],  
  [10,13,18,22,26],[5,17,20,29],[6,12],[3,9,11,21,22,28],[7,12,19],  
  [9,13,16,18,21],[2,8,14],[3,6,9,15],[4,11,14,15,16],[5,10,19],  
  [10,15,18,22],[4,5,6,8,0,13,22,23,25,28,30],[7,9,10,12,15,17,19,21,24],[5,0,8,10,14,16,17,19],[4,5,11,13,17],  
  [12,16],[9,11,14,16,0],[3,0,9,15,0,20,58],[2,10],[11,15],  
  [7,9,14,16,22,24,28],[-1,7,-1,15,-1,44,48],[2,-1,7,-1,8,9,-1,12,13,14,-1,18,-1,20,-1,22,23,24,25,-1],[5,7,8,9,10] 
],
[//Joshua - 24
  [10,12,16],[8,15,23],[7,9,14],[10,15,19],[2,10,12,13],  
  [6,8,12,26],[6,10,16,22],[3,9,14,30,32],[3,16,22],[6,8,12,15,28,29,31,33,34,36,38,40],  
  [6,10,15,21],[7],[15,22,24,29],[6],[13,16,20,33,48,61,63],  
  [5],[3,7,14],[8,11,21],[10,17,24,32,40,49,51],[7],  
  [9,13,20,27,34,41,43],[9,11,12,15,21,30,32],[1],[14,16,26,29,32]  
],
[//Judges - 21
  [9,16,22,27,29,30,31,33,34],[6,11,14,16,20],[5,8,12,15,24,26,31],[4,10,17],[2,-1,31],  
  [7,11,19,25,28,33,36],[9,15,19,24],[4,8,10,13,18,22,24,28,29,32],[7,22,26,30,34,46,50,56],[3,6,10,15],  
  [4,12,29,32,34],[8,11,13],[2,6,8,15,24],[5,8,10,19],[3,6,7,9,14,18],  
  [4,6,15,21,23],[7],[7,11,14,22,30],[16,22,29],[8,12,18,26,36],  
  [8,16,25]  
],
[//Ruth - 4
  [6,19],[4,18],[6,8,14],[6,9,13,18]  
],
[//1 Samuel - 31
  [4,9,19,24],[2,-1,11,12,18,20,22,27],[11,15,19],[12,19],[6,10],  
  [10,17,19,21],[5,7,13,15],[6,10,19],[11,15,25],[9,14,17,26],  
  [4,12],[6,16,20],[5,8,15,17,19],[4,16,24,36,47,49],[4,10,24,32,34],  
  [6,14,19],[4,12,20,28,30,32,38,48,55],[5,10,12,17,22,28,30],[4,8,12,18],[11,18,24,35,41],  
  [8,10],[3,5,6,9,17,20],[6,9,13,16,19,27,29],[9,16],[3,4,14,18,32,36,39,44],  
  [5,13,17,21],[5,8],[3,7,15,21],[6],[11,16,21,26],  
  [7,11]  
],
[//2 Samuel - 24
  [13,17,19,-1],[5,8,12,18,25,32],[2,6,12,17,22,28,31],[9],[4,6,11,13,17,22],  
  [6,12,17,20],[4,12,18],[3,9,14,15],[5,7,9],[6,15],  
  [2,6,14,18,22,26],[7,15,24,26,28],[6,9,15,21,23,27,28,30,37],[4,21,25,28],[7,10,13,19,24,30,31,32],  
  [5,9,15,20],[15,23,24,27],[6,9,18,19,24,33],[9,11,16,24,31,41],[3,4,14,16,23],  
  [10,12,15],[2,-1],[2,-1,8,13,18,24],[5,10,15,18]  
],
[//1 Kings - 22
  [5,11,15,22,28,32,41,50],[10,12,13,19,26,28,36],[5,16],[7,20,22,26,29],[7,13],  
  [5,11,14,23,31,36,37],[6,7,8,9,10,13,23,27,38,40],[12,22,31,33,35,37,41,44,46,54,56,62,65],[10,15,24,25,28],[14,16,18,21,24,26,28],  
  [9,14,23,26,41],[6,12,16,21,25],[11,20,23,33],[5,14,17,19,21,25,29],[7,9,16,23,25,27,31,32],  
  [5,7,8,11,14,15,20,21,23,25,27,29,34],[8,17],[7,17,21,25,30,36,41],[4,9,19],[13,22,23,26,28,31,35],  
  [5,15,17,25,27],[13,15,29,37,39,41,45,47,50,51]  
],
[//2 Kings - 25
  [5,9,11,13,17,18],[9,12,16,19,23],[4,6,9,21,26],[8,11,18,31,38,42],[8,15,20],  
  [8,15,20,24],[3,12,17],[7,16,20,23,25,28],[4,11,27,29,30],[6,8,12,15,18,29,32,34],  
  [4,13,17],[4,17,19],[3,8,10,12,14,20,22],[5,8,15,17,21,23,28],[5,6,8,11,12,13,15,16,21,23,26,27,31,32,35,36],  
  [5,10,17,19],[7,24,29],[4,9,13],[8,14,20,21,-1,29,35],[8,12,14,20],    
  [10,17,19,23,25],[3,8,14],[3,4,15,21,24,26,29,31,36],[5,8,10,17],[4,8,13,18,22,27]  
],
[//1 Chronicles - 29
  [5,8,17,24,29,32,35,43,51],[3,13,18,21,25,34,42,50],[10,17],[5,9,11,21,24,34,39],[11,18,23,25],  
  [4,16,31,49,54,61,71,77],[6,13,14,20,28,30],[29,33],[2,10,14,27,35],[8,11,13],  
  [4,10,15,20,26],[23],[9],[3,8],[11,25,29],  
  [4,7,8,-1,14,-1,19,-1,23,-1,31,-1,34,-1,37],[3,11,16],[3,9,14],[6,16],[4],  
  [5,9,14,18,28],[6,17],[7,12,21,24],[20],[8],  
  [13,20,29],[16,25],[9,11],[6,10,20,26]  
],
[//2 Chronicles - 36
  [7,13],[3,11,17],[3,10,14],[2,6,11,19],[2,11],  
  [12,22,24,26,28,32,34,40],[4,8,11,12],[7,11,12,14,17],[13,15,20,23,25,26,29],[6,16],  
  [5,13,18],[5,13],[4,13,21],[6,9],[8,16,18],  
  [7,11,13],[7,10,12],[4,9,12,23,28],[5,8],[5,14,20,22,26,31,34,35],  
  [5,8,12,16,18],[5,10],[12,16],[4,15,23,27],[3,5,11,14,17,25,27],  
  [16,22],[5,7,9],[6,16,22,26],[3,12,20],[13,21,27],  
  [2,5,11,20],[9,21,24,27,31,32],[10,14,18,20,21,25],[3,8,14,22,29],[7,10,20,25,26],  
  [5,8,9,11,14,22,23]  
],
[//Ezra - 10 
  [2,5,7],[36,40,41,42,43,55,59,61,64,68],[8],[7,11,17,23],[3,6],  
  [3,6,13,16,19],[11,12,27],[15,21,24,31,33,36],[5],[6,9,15,18]  
],
[//Nehemiah - 13
  [4],[9,12,17,19],[1],[7,13,19],[6,14],  
  [10,15,17],[5,6,39,43,44,45,46,57,63,66,70],[9,13],[4],[28],  
  [3,20],[10,22,27,31,44],[4,10,15,23]  
],
[//Esther - 10 
  [10,13],[5,8,12,15,21],[7,8],[4,10,15],[6,9,14],  
  [4,12],[5,7],[3,7,15],[11,16,20],[1]  
],
[//Job - 42
  [4,6,13,21,22],[7,9,11],[3,-1,11,-1,20,-1],[-1,12,-1],[2,-1,8,-1,17,-1],  
  [2,-1,8,-1,14,-1],[2,-1,11,-1],[2,-1,8,-1],[2,-1,11,-1,16,-1,27,-1],[2,-1,8,-1,13,-1,18,-1],  
  [2,-1,7,-1,13,-1],[2,-1,7,-1,11,-1],[2,-1,6,-1,13,-1,17,-1],[2,-1,13,-1],[2,-1,7,-1,14,-1,17,-1,31,-1],  
  [2,-1,9,-1,15,-1,18,-1],[2,-1,11,-1],[2,-1,9,-1,20,-1],[2,-1,7,-1,21,-1],[2,-1],  
  [2,-1,7,-1,17,-1,22,-1,27,-1],[2,-1,5,-1,12,-1,15,-1,21,-1],[2,-1],[2,-1],[2,-1],  
  [2,-1,5,-1],[2,-1,7,-1],[2,-1,12,-1],[2,-1],[2,-1,9,-1,15,-1,20,-1,25,-1],  
  [2,-1,13,-1,16,-1,24,-1,29,-1,35,-1],[7,-1],[2,-1,8,-1,12,-1,23,-1,31,-1],[2,-1],[2,-1,9,-1,14,-1],  
  [2,-1,5,-1,16,-1,22,-1],[2,-1,14,-1,19,-1],[2,-1,4,-1,12,-1,19,-1,31,-1],[2,-1,9,-1,13,-1,19,-1,26,-1],[2,3,4,6,7,-1,15,-1],  
  [2,-1,12,-1,25,-1,30,-1],[2,-1,7,10,16]  
],
[//Psalm - 150
  [-1,4,-1],[-1,4,-1],[-1],[-1],[-1],  
  [-1,8,-1],[-1,6,-1,10,-1,17,-1],[-1,2,-1,9,-1],[-1,3,-1,7,-1,11,-1,15,-1,19,-1],[-1,12,-1],  
  [-1,4,-1],[-1,6,-1],[-1],[-1,7,-1],[-1],  
  [-1,7,-1],[-1,6,-1,13,-1,15,-1],[2,-1,4,-1,7,-1,16,-1,20,-1,25,-1,30,-1,37,-1,43,-1,46,-1],[-1,7,-1,14,-1],[-1,6,-1],   
  [-1,8,-1,13,-1],[2,-1,9,-1,19,-1,22,-1],[-1],[-1,7,-1],[-1,8,-1,16,-1,22,-1],   
  [-1,4,-1],[-1,7,-1,14,-1],[-1,6,-1],[-1,3,-1,10,-1],[-1,4,-1,6,-1,11,-1],   
  [-1,9,-1,14,-1,19,-1,23,-1],[-1,3,-1,5,-1,8,-1,10,-1],[-1,6,-1,10,-1,16,-1,22,-1],[-1,4,-1,11,-1],[-1,4,-1,9,-1,11,-1,17,-1,19,-1,27,-1],  
  [-1,5,-1,11,-1],[-1],[-1,9,-1,13,-1,21,-1],[-1,7,-1,12,-1],[-1,7,-1,11,-1],  
  [-1,4,-1,10,-1],[-1,5,-1,11,-1],[-1,5,-1],[-1,4,-1,9,-1,17,-1,23,-1],[-1,10,-1],  
  [-1,10,-1],[-1,5,-1],[-1,9,-1],[-1,5,-1,14,-1,20,-1],[-1,16,-1],   
   [-1,4,-1,7,-1,14,-1,18,-1],[-1,6,-1,8,-1],[-1,6,-1],[-1,4,-1,6,-1],[-1,9,-1,15,-1,22,-1], 
   [-1,3,-1,5,-1,8,-1,10,-1,12,-1],[-1,4,-1,7,-1],[-1,6,-1,10,-1],[-1,3,-1,16,-1],[-1,6,-1,9,-1],  
   [-1,8,-1],[-1,3,-1,5,-1,9,-1,11,-1],[-1],[-1,7,-1],[-1,9,-1],  
   [-1,5,-1,8,-1,13,-1,16,-1,20,-1],[-1,3,-1,6,-1],[-1,4,-1,7,-1,11,-1,15,-1,19,-1,22,-1,24,-1,32,-1,35,-1],[-1,5,-1,13,-1,19,-1,29,-1,34,-1],[-1,5,-1],   
   [-1,5,-1,17,-1],[-1,18,-1],[-1,13,-1,21,-1],[-1,4,-1,9,-1,12,-1,18,-1,22,-1],[-1,4,-1,9,-1],   
   [-1,4,-1,10,-1],[-1,4,-1,7,-1,10,-1,16,-1],[-1,5,-1,9,-1,12,-1,17,-1,21,-1,32,-1,40,-1,56,-1,65,-1],[-1,5,-1,11,-1],[-1,4,-1,8,-1,14,-1,19,-1],   
   [-1,6,-1,11,-1,13,-1],[-1],[-1],[-1],[-1],  
   [-1],[-1],[-1],[-1],[-1],  
   [-1],[-1],[-1],[-1],[-1],  
   [-1],[-1],[-1],[-1],[-1], 
  [-1],[-1],[-1],[-1],[-1], 
  [-1],[-1],[-1],[-1],[-1],  
  [-1],[-1],[-1],[-1],[-1],  
  [-1],[-1],[-1],[-1],[-1],   
  [-1],[-1],[-1],[-1],[-1],   
  [-1],[-1],[-1],[-1],[-1],   
  [-1],[-1],[-1],[-1],[-1],  
  [-1],[-1],[-1],[-1],[-1],  
  [-1],[-1],[-1],[-1],[-1],  
  [-1],[-1],[-1],[-1],[-1]
],
[//Proverbs - 31
  [-1],[-1],[-1],[-1],[-1],  
  [-1],[-1],[-1],[-1],[-1],  
  [-1],[-1],[-1],[-1],[-1],  
  [-1],[-1],[-1],[-1],[-1],  
  [-1],[-1],[-1],[-1],[-1],  
  [-1],[-1],[-1],[-1],[-1],  
  [-1]  
],
[//Ecclesiastes - 12
  [0,12],[4,12,20,24],[0,9,16,18],[4,7,13],[8,9,18],  
  [3,7,10],[0,14,23],[6,10,16],[4,7,11,13],[0],  
  [0,5,7,9],[8,9,13]  
],
[//Song of Solomon - 8
  [0],[0],[0],[0],[0],  
  [0],[0],[0]  
],
[//Isaiah - 66
  [2,-1],[2,-1],[-1],[1],[-1],  
  [-1],[10,17],[5,9,11,19],[2,-1],[-1],  
  [-1],[-1],[2,-1],[5,-1,22,24,-1,28,29,-1],[-1],  
  [-1,13],[-1],[-1],[-1,16,18,23],[1],  
  [-1],[-1,15,16,-1],[-1,15,17],[-1],[-1],  
  [-1],[-1],[-1],[-1,11,13,-1,22,-1],[-1,19,27,-1],  
  [-1],[-1],[-1],[-1],[-1],  
  [4,11,13,22],[6,8,14,21,23,-1,36,37],[4,9,10,-1,21],[3],[-1],  
  [-1],[-1],[-1],[-1],[-1],  
  [-1],[-1],[-1],[-1],[-1],  
  [-1],[-1],[-1],[-1],[-1],  
  [-1],[-1],[-1],[-1],[-1],  
  [-1],[-1],[-1],[-1],[-1], 
  [-1,18]  
],
[//Jeremiah - 52
  [1,6,11,13,17],[2,-1],[-1,6,12,14,20],[-1,18,19,20,-1],[-1],  
  [-1],[8,17,21,29,32],[4,-1],[-1,12,17,-1,25],[-1],  
  [6,9,11,15,18],[-1,14],[12,15,-1],[-1,10,11,17,-1],[10,15,-1],  
  [10,14,16,19,-1],[5,-1,19],[11,13,-1,18,19,-1],[14],[7,-1],  
  [3,8,11,-1],[10,13,18,-1,24,28],[5,7,9,-1,15,18,-1,26,33],[4,8],[8,12,15,27,30,-1,32,34,-1], 
  [8,10,12,16,19,20,24],[12,16,19],[5,10,12,15],[8,10,15,20,24,30],[4,10,-1],  
  [-1,23,27,31,35,38],[6,13,16,26,36],[9,15,17,19,23],[8,12],[12,18],  
  [4,9,11,20,27,32],[6,11,16],[7,14,24],[4,8,11,15],[7,13],  
  [11],[7,13,19],[8],[11,15,20,24,29],[1],  
  [3,-1,13,14,-1],[2,-1],[-1],[-1,7,-1,12,14,-1,17,20,23,-1,28,-1,34,-1],[4,6,9,17,21,22,30,33,34,35,39,41,44,45],  
  [-1,59],[4,8,12,17,24,28,31]  
],
[//Lamentations - 5  
  [-1],[-1],[-1],[-1],[-1]  
],
[//Ezekiel - 48
  [4,15,26],[6,9],[,4,10,12,16,22],[9,14,16],[5,7,12],  
  [8,11],[16,20,23],[5,7,13,15,17],[5,8],[8,9,18,20],  
  [5,13,14,22,24],[7,8,17,21,26],[10,17],[6,12,15,17,19,22],[6],  
  [6,15,20,23,35,44,53,60],[7,9,11,,19,22],[5,10,14,19,21,24,25,30],[-1],[4,8,10,15,22,27,33,39,45,49],  
  [8,14,18,25,28],[13,17,23],[5,11,22,28,32,35,36,40,43,45],[8,9,15,19,25],[8,12,15],  
  [7,15],[-1,12,26],[-1,11,13,-1,20,24],[3,-1,8,13,17,21],[-1,20],  
  [-1,10,15,18],[2,-1,17,22,24,26,27,29,30,31],[7,10,12,17,20,21,23,30],[7,11,17,20],[10],  
  [8,16,21,25,33,37],[4,7,11,15,18,20],[8,10,14,17],[6,8,11,14,17,21,23,25],[6,17,20,24,28,32,35,39,44,48],  
  [5,8,13,23],[13,15,19],[7,10,13,18],[4,15,17],[6,7,9,13,18],
  [9,16,19,21],[6,13,22],[8,15,21,30]
],
[//Daniel - 12
  [3,8,17],[10,14,19,21,22,23,24,31,36,46],[8,13,19,26],[4,8,19,28,34],[5,10,17,25,30],   
  [4,10,18,24,25],[9,15,19,23],[13,15],[3,16,20],[2,10,15,18],  
  [5,10,14,20,29,36,40],[5,8]  
],
[//Hosea - 14 
  [2,6,8,10],[0],[1],[0],[0],  
  [0],[0],[0],[0],[0],  
  [0],[0],[0],[0]  
],
[//Joel - 3  
  [0],[0],[0]  
],
[//Amos - 9 
  [0],[0],[0],[0],[0],  
  [0,9,11,0],[4,7,10,14],[0],[0]  
],
[//Obadiah - 1
  [0,19]  
],
[//Jonah - 4
  [4,7,11,17],[3,0],[5,10],[4,5,9]  
],
[//Micah - 7
  [0],[0],[0],[0],[0],  
  [0],[0]  
],
[//Nahum - 3
  [0],[0],[0]  
],
[//Habakkuk - 3
  [0],[0],[0]  
],
[//Zephaniah - 3
  [0],[0],[0]  
],
[//Haggai - 2
  [7,12],[6,10,20]  
],
[//Zechariah - 14  
  [7,12,18],[6,10,13],[1],[8,11],[5],  
  [9],[4,8],[9,16,18,20],[0],[0],  
  [0,4,10,15],[6,9],[2,7],[4,12,16,20]  
],
[//Malachi - 4
  [6,12],[10,14,17],[2,5,7,8,13,16],[2,4,5]  
],
[//Matthew - 28 
  [17,18],[7,9,13,16,19],[7,13],[5,8,12,17,18,23],[13,17,21,27,33,38,43],  
  [5,9,16,19,22,24],[6,7,13,15,21,24,28],[5,14,16,18,23,28],[9,10,14,18,20,23,27,32,35],[5,16,29,30,32,34,40],  
  [7,16,20,25,28],[9,14,22,31,38,43,46],[10,18,24,31,33,34,36,44,45,47,51,53],[3,13,15,22,34],[10,12,15,21,29,32],  
  [5,13,21,24],[9,14,22,24],[7,15,21],[3,10,13,16,23,27],[17,20,24,29],  
  [6,12,14,18,23,28,33],[15,23,34,41],[13,16,23,29,34],[3,9,15,23,29,32,36,43],[14,31],  
  [6,14,17,20,26,30,36,40,45,47,51,55,57,67,69],[3,11,15,19,24,27,33,39,45,50,55,57,62],[9,11,16]  
],
[//Mark - 16  
  [4,9,12,14,21,29,32,35,40],[13,18,23],[7,13,20,31],[21,24,26,30,35],[21,25,35],  
  [7,14,17,30,45,53],[9,14,24,31],[10,14,22,27,34],[2,9,14,30,33,38],[2,13,17,23,28,32,35,41,46],  
  [12,15,20,27],[13,18,28,35,38,41],[9,14,24,28,32],[3,10,12,17,22,26,32,37,39,43,46,53,55,60,66],[6,16,22,29,33,40,42],  
  [9,12,14,19]  
],
[//Luke - 24  
  [5,18,21,24,26,34,39,46,0,57,65,67,0],[6,8,15,21,22,29,0,33,36,41],[7,10,15,18,21,23],[5,9,14,16,21,28,33,38,40,42],[12,17,21,27,33,36],  
  [6,12,17,20,24,27,39,43,46],[11,18,24,31,36],[4,16,19,22,26,37,40,43,49],[7,10,18,23,28,37,43,46,49,51,57],[13,17,21,23,25,29,38],  
  [5,14,27,29,33,37,45,53],[13,22,41,49,54,57],[6,10,18,22,31],[7,12,15,25,34],[3,8,11,25],  
  [14,19],[5,11,20,22,26],[9,15,18,31,35],[11,28,41,45,47],[9,19,27,39,45],  
  [5,10,20,29,34,37],[3,7,14,19,21,24,31,35,39,47,54,63,66],[8,12,13,27,32,34,39,44,50],[13,28,36,50]  
],
[//John - 21  
  [8,15,19,24,29,35,43],[12,23],[9,22,25,31],[27,31,39,43],[10,16,31],  
  [14,16,22,41,52,59,66],[10,14,19,25,32,40,45],[12,21,31,41,48,52,59],[8,13,18,24,35,39],[6,19,22,31,39],  
  [7,17,28,32,38,45,47,55],[9,12,17,20,23,27,34,37,42,44],[12,18,21,31,36],[5,8,15,22,27],[18],  
  [12,17,19,25,29],[6,11,13,20,24],[12,15,19,25,28,33,38],[4,8,12,13,16,19,23,25,28,31,38],[10,14,19,24,26,30],  
  [4,15,20,24,25]  
],
[//Acts - 28  
  [6,9,12,15,23],[5,14,22,29,37,41,44],[11,19],[5,13,23,31,32],[7,12,17,27,29,33,41],  
  [8],[9,17,23,30,37,44,51,54],[5,14,18,25,26,32],[10,17,20,23,32,36],[9,17,23,34,44],  
  [18,19,22,25,27],[6,12,18,20,24],[4,13,26,32,38,42,44,50],[8,19,24],[6,12,13,22,30,36],  
  [6,13,16,19,25,35],[5,10,16,22,32],[5,7,12,18,24],[8,13,21,23,35],[7,13,17,28,32,36],  
  [7,15,18,27,37,40],[12,17,22,30],[6,11,12,16,25,31],[-1,17,22,24],[6,13,23],  
  [4,12,19,24,30],[9,21,27,33,39],[7,11,16,23,30]  
],
[//Romans - 16  
  [8,18,26],[12,17],[9,21,27],[1],[6,12],  
  [12,15],[7,13,21],[5,12,18,26,31],[6,14,19,30],[1],  
  [7,13,25,33],[9],[11],[13,19],[8,14,22,30],  
  [17,21,25]  
],
[//1 Corinthians - 16  
  [4,10,18],[6],[10,18],[6,14],[6,9],  
  [12],[8,10,12,17,25,29,32],[7],[3,18,24],[6,11,14,18,23,25,27],  
  [13,17],[4,12,27],[4,8,11],[18,20,26,34,36],[12,24,33,35,45,50],  
  [5,10,13,15,19,21,22,23,24]  
],
[//2 Corinthians -13 
  [3,12,15,23],[5,12],[12],[7],[11],  
  [11,14],[2,5],[10,16],[6],[7,12],  
  [7,16,28],[14,19],[5,14]  
],
[//Galatians - 6 
  [6,11],[11,15],[15,19,21,23],[8,12,21],[13,19],  
  [11,17,18]  
],
[//Ephesians - 6
  [3,15],[11,19],[14,20],[17,25],[22],  
  [5,10,21,23]  
],
[//Philippians - 4
  [3,12,27],[12,19],[17],[4,10,15,21,23]  
],
[//Colossians - 4
  [3,9,21],[6,16],[5,12,18],[7,10,17,18]  
],
[//1 Thessalonians - 5 
  [2],[13,17],[6,11],[9,13],[12,16,23,25,27,28]  
],
[//2 Thessalonians - 3
  [3],[13],[6,13,16,17,18]  
],
[//1 Timothy - 6 
  [3,12,18],[8],[8,14],[6,11],[17,23],  
  [3,11,17,20]  
],
[//2 Timothy - 4
  [3,15],[8,11,14,22],[10],[6,9,14,19,20,22]  
],
[//Titus - 3
  [5,10],[11],[12,15]  
],
[//Philemon - 1
  [4,8,17,23,25]  
],
[//Hebrews - 13
  [1],[5,10],[7,12],[12],[11],  
  [9,13],[4,11,15,20,26],[7],[6,11,15,23],[5,11,19,26,32],  
  [13,17,32],[18],[10,18,20,22,25]  
],
[//James - 5  
  [2,12,19],[14],[13],[11,13],[7,12,13,19]  
],
[//1 Peter - 5 
  [13],[11,13,18],[8,123],[7,12],[5,8,12,13,14]  
],
[//1 Peter - 3 
  [5,12],[17],[8,11,14]  
],
[//1 John - 13
  [5],[7,12,15,18,22,26],[4,11,18],[7],[13,16]  
],
[//2 John - 1  
  [4,12,13]  
],
[//3 John - 1
  [9,11,13]  
],
[//Jude - 1
  [3,5,10,14,17,24]
],
[//Revelation - 22
  [7,8,9],[8,12,18],[7,14],[1],[5,11],  
  [3,5,7,9,12],[9,13],[2,7,8,10,12],[13],[8],  
  [4,15],[7,13],[5,9,11],[6,8,9,13,14,17],[5],  
  [3,4,8,10,12,17],[7,15],[4,9,21],[5,9,11,17],[4,7,11],  
  [5,9,15,22],[6,7,8,10,12,15,16,17,20,21]  
]
];
//alert(_paragraphs[0][1]);  //book 0, chapter 1, [list of paras]

/*  
 para[] = GetCVParas[];   - n total verses --> Create para[n] array
 
 <p><s>xx</s></p> 2 
 <p><s>xx</s>     1  
   <s>xx</s>      0
   <s>xx</s></p>  3
   
new - Introduce -1 .. same as 0 but the Spans all break to new line (no vertical space)

 <p><s>xx</s>       1  
 <s br>xx</s>       -1
 <s br>xx</s></p>   3
 
 Ideas
 <3,9> Paragraps 1-2,3-8,9-end 
 There are 3 types of paragraphs 
 -- No Paragraps -- singles verses (like paragraphs off) --         <0,3,9><0001111112222__________>
 -- Single paragraph - verses no-breaks                             <><111111111111__________> 
 -- Single paragrah - verses start new line with just verse number  <222222222______>
   
 So ALL text in <span>xx</span>
 2 = single - start <p> and closing </p>
 1 = start <p>
 0,-1 = lines between
 3 = end </p>
 
 103, 1003, 1-1,3, 13, 2, 22, - are all valid patters in  paragraph string

*/
function FillParam_Span(ret, k1, k2, midNum) {  //mid is middle code 0 or -1
  var k;
  for (k = k1; k <= k2; k++) {
    if (k1 == k2) ret[k] = 2; 
    else if (k == k1) ret[k] = 1; 
    else if (k == k2) ret[k] = 3;
    else ret[k] = midNum;
  }
}
function FillParam_Singles(ret, k1, k2) {
  var k;
  for (k = k1; k <= k2; k++) 
    ret[k] = 2; 
}
function ValidateCVParas(ret, bkIdx,ch){  // 103, 1003, 13, 2, 22, - are all valid patters 
  var i, last = 2, ok;
  for (i = 0; i < ret.length; i++) {
    if (ret[i] <= 0)
       ok = (last === ret[i] || last === 1);  // 0 follows 0 or 1 - between 1 & 3      
    else if (ret[i] === 1) 
       ok = (last === 2 || last === 3);  // 1 new seq, follows 2 or 3  
    else if (ret[i] === 2)
       ok = (last === 2 || last === 3);  // 2 new seq, follows 2 or 3   
    else if (ret[i] === 3)
       ok = (last <= 0 || last === 1);  // 3 is end of 13 or 1003 seq
    else 
       ok = false;
    last = ret[i];
    if (!ok)
      break;
  }
  // last is always 2 or 3 end of seq
  if (!ok || last <= 0 || last === 1) {
    alert("checksum_failed_131: paragraph data."
         +"\nOrig: ["+_paragraphs[bkIdx][ch]+"]"
         +"\nRes: ["+ret+"]"
         +"\n"+kjvObj.book[bkIdx].name 
         +"\nch:"+(ch+1)
         ); 
    return false;  
  }
  return true;
}
function GetCVParas(bkIdx, ch, totalverses) {  // bk, ch are all zero based - returns expanded verse array 
  var i, ret = []; 
   
  //default: separate paragraphs  [1,0,....,0,3,end]
  for (i = 0; i < totalverses; i++)
    ret[i] = 2; 
   
  //Only one verse? or no data
  if (totalverses == 1 
      || (bkIdx >= _paragraphs.length)
      || _paragraphs[bkIdx] === "undefinded" 
      || (ch >= _paragraphs[bkIdx].length)
      || _paragraphs[bkIdx][ch] === "undefinded") 
    return ret; //return default - valid ret for no definition
  
  // param info for bk/ch
  var p, pp = _paragraphs[bkIdx][ch];  //copy by ref - so don't change pp[]

  
  // No data defined - return default (single chapters)
  if (pp.length === 0)
    return ret;  
  
  // single [1] --> single paragraph of verses - only place "1" used (in initial unexpanded data)
  if (pp.length === 1 && pp[0] === 1) {
    if (totalverses === 1)
      return ret;      // [2]
    for (i = 0; i < totalverses; i++)
      ret[i] = 0;
    ret[0] = 1; 
    ret[totalverses-1] = 3;    // [1,0,0,0,0,3]
    return ret; 
  }
  
  
  var k1 = 0, k2 = 0; last = -1;
  for (p = 0; p < pp.length; p++) {
    
    //validate ascending order -- skip ZERO as sepecial meaning
    if (pp[p] > 0)
    {
      if (last > pp[p])
        alert("ERROR:Invalid_Paragraph_data_Sequence_132: Not in ascending order."
             +"\nBkIdx:"+ bkIdx+" ch:"+(ch+1)
             +"\n["+pp+"]");
      last = pp[p];
    }
    
    
    if (pp[p] == 0)   //special - fill with sing pars
    { 
      if (p == pp.length-1) {  // last -- fill ret[] to end with Singles (2)
        k2 = ret.length-1;
        FillParam_Singles(ret, k1, k2);
        return ret;
      }
      else {
        p++;
        k2 = pp[p]-2;
        FillParam_Singles(ret, k1, k2);
        k1 = k2+1;
        k2 = k1;
        if (p == pp.length-1) {   //last item
          k2 = ret.length-1;
          FillParam_Span(ret, k1, k2, 0);
          return ret;
        }
        continue;
      }
    }
    else if (pp[p] == -1)   //special - items all line brreaks -- 1 -1 -1 -1 3
    { 
      if (p == pp.length-1) {  // last -- fill ret[] to end with Singles (2)
        k2 = ret.length-1;
        if (pp[p] == -1)
          FillParam_Span(ret, k1, k2, -1);
        else 
          FillParam_Singles(ret, k1, k2);
        return ret;
      }
      else {
        p++;
        k2 = pp[p]-2;
        FillParam_Span(ret, k1, k2, -1);
        k1 = k2+1;
        k2 = k1;
        if (p == pp.length-1) {   //last item
          k2 = ret.length-1;
          FillParam_Span(ret, k1, k2, 0);
          return ret;
        }
        continue;
      }
    }
    else {
       k2 = pp[p]-2;
//rwc
//if (ch == 65) alert(['debugA:k1-k2=',k1,k2,"--",pp]);
  
       //if (pp[p] <= 0)
       //  FillParam_Span(ret, k1, k2, pp[p]);
       //else 
         FillParam_Span(ret, k1, k2, 0);
      
//rwc
//if (ch == 65) alert([pp[p],'debugB:k1-k2-ret=',k1,k2,"--[", ret, "]\n", "[2,-1,7,-1,8,-1,12,13,-1,18,-1,20,-1,22,23,24,-1]"]);
       k1 = pp[p]-1;
       k2 = pp[p]-1;
       if (p == pp.length-1) {   //last
          k2 = ret.length-1;
          if (pp[p] <= 0)
            FillParam_Span(ret, k1, k2, pp[p]);
          else
            FillParam_Span(ret, k1, k2, 0);
          return ret;
       }
    }
  }
  return ret;
}

/*
var test = [];  //bk,ch, TotalVs
var test = GetCVParas(4, 31, 52);  //Deut=4 Chapt 32 [17]
alert("["+_paragraphs[4][31] + "] --> \n"
 +test +" - "+test.length);
ValidateCVParas(test);
*/





