//General kjv bible support code
var kjv_js_version = 2; //used by tools.html

var kjv_JsFiles = [ //6xJS bible files -- var name | BookIndex (of first book in JS file) | Num books in JS file | filename
  ["kjv_gen",0,5,   "kjv0_gen.js"], 
  ["kjv_jos",5,8,   "kjv1_jos.js"], 
  ["kjv_2ch",13,9,  "kjv2_2ch.js"], 
  ["kjv_isa",22,17, "kjv3_isa.js"], 
  ["kjv_mat",39,5,  "kjv4_mat.js"], 
  ["kjv_rom",44,22, "kjv5_rom.js"]
];
var kjv_index = [  //Bible Book # | JS File # | Index info File | Fullname | ChapterCount | 
  //OLD TESTAMENT
  [1,  0, 0, "Genesis",         50, "Gen"],
  [2,  0, 1, "Exodus",          40, "Exo"],
  [3,  0, 2, "Leviticus",       27, "Lev"],
  [4,  0, 3, "Numbers",         36, "Num"],
  [5,  0, 4, "Deuteronomy",     34, "Deu"],
  [6,  1, 0, "Joshua",          24, "Jos"],
  [7,  1, 1, "Judges",          21, "Jdg"],
  [8,  1, 2, "Ruth",            4,  "Rth"], 
  [9,  1, 3, "1 Samuel",        31, "1Sa"],
  [10, 1, 4, "2 Samuel",        24, "2Sa"],
  [11, 1, 5, "1 Kings",         22, "1Ki"],
  [12, 1, 6, "2 Kings",         25, "2Ki"],
  [13, 1, 7, "1 Chronicles",    29, "1Ch"],
  [14, 2, 0, "2 Chronicles",    36, "2Ch"],
  [15, 2, 1, "Ezra",            10, "Ezr"],
  [16, 2, 2, "Nehemiah",        13, "Neh"],
  [17, 2, 3, "Esther",          10, "Est"],
  [18, 2, 4, "Job",             42, "Job"],
  [19, 2, 5, "Psalm",           150,"Psa"],
  [20, 2, 6, "Proverbs",        31, "Pro"],
  [21, 2, 7, "Ecclesiastes",    12, "Ecc"],
  [22, 2, 8, "Song of Solomon", 8,  "Son"],
  [23, 3, 0, "Isaiah",          66, "Isa"],
  [24, 3, 1, "Jeremiah",        52, "Jer"],
  [25, 3, 2, "Lamentations",    5,  "Lam"],
  [26, 3, 3, "Ezekiel",         48, "Eze"],
  [27, 3, 4, "Daniel",          12, "Dan"],
  [28, 3, 5, "Hosea",           14, "Hos"],
  [29, 3, 6, "Joel",            3,  "Joe"],
  [30, 3, 7, "Amos",            9,  "Amo"],
  [31, 3, 8, "Obadiah",         1,  "Oba"],
  [32, 3, 9, "Jonah",           4,  "Jon"],
  [33, 3, 10, "Micah",          7,  "Mic"],
  [34, 3, 11, "Nahum",          3,  "Nah"],
  [35, 3, 12, "Habakkuk",       3,  "Hab"],
  [36, 3, 13, "Zephaniah",      3,  "Zep"],
  [37, 3, 14, "Haggai",         2,  "Hag"],
  [38, 3, 15, "Zechariah",      14, "Zec"],
  [39, 3, 16, "Malachi",        4,  "Mal"],
  //NEW TESTAMENT
  [40, 4, 0, "Matthew",         28, "Mat"],
  [41, 4, 1, "Mark",            16, "Mar"],
  [42, 4, 2, "Luke",            24, "Luk"],
  [43, 4, 3, "John",            21, "Joh"],
  [44, 4, 4, "Acts",            28, "Act"],
  [45, 5, 0, "Romans",          16, "Rom"],
  [46, 5, 1, "1 Corinthians",   16, "1Co"],
  [47, 5, 2, "2 Corinthians",   13, "2Co"],
  [48, 5, 3, "Galatians",       6,  "Gal"],
  [49, 5, 4, "Ephesians",       6,  "Eph"],
  [50, 5, 5, "Philippians",     4,  "Php"],
  [51, 5, 6, "Colossians",      4,  "Col"],
  [52, 5, 7, "1 Thessalonians", 5,  "1Th"],
  [53, 5, 8, "2 Thessalonians", 3,  "2Th"],
  [54, 5, 9, "1 Timothy",       6,  "1Ti"],
  [55, 5, 10, "2 Timothy",      4,  "2Ti"],
  [56, 5, 11, "Titus",          3,  "Tit"],
  [57, 5, 12, "Philemon",       1,  "Phm"],
  [58, 5, 13, "Hebrews",        13, "Heb"],
  [59, 5, 14, "James",          5,  "Jam"],
  [60, 5, 15, "1 Peter",        5,  "1Pe"],
  [61, 5, 16, "2 Peter",        3,  "2Pe"],
  [62, 5, 17, "1 John",         5,  "1Jo"],
  [63, 5, 18, "2 John",         1,  "2Jo"],
  [64, 5, 19, "3 John",         1,  "3Jo"],
  [65, 5, 20, "Jude",           1,  "Jud"],
  [66, 5, 21, "Revelation",     22, "Rev"]
];


/*
kjvObj global store - initialized below - access data here NOT in above structures

  6xJS File Loading jsStatus eg. "kjv/kjv_gen.js"
    0 = Not loaded
    1 = Loading - Standby
    2 = Done: Error Loading (missing file?)
    3 = Done: Loaded OK (ready to access)

  array of JS files and load state
        
    kjvObj.js[jsIdx].name           eg. "kjv_gen"
    kjvObj.js[jsIdx].path           eg. "kjv/kjv_gen.js"
    kjvObj.js[jsIdx].jsStatus       eg. JS File Load jsStatus - 0(default),1(loading),2(error),3(Loaded)
    kjvObj.js[jsIdx].bkOne          eg. Book index of book #1 eg. 0 kjv_gen file, 5 for kjv_jos etc
    kjvObj.js[jsIdx].bkNum          eg. Num books in this JS file

  array of 66 books info 
       
    kjvObj.book[index].chapter[]    eg. When bible loaded this is filled
    kjvObj.book[index].chapters     eg. Num chapters in book (always available even if JS not loaded)
    kjvObj.book[index].name         eg. Name of bible book
    kjvObj.book[index].name_        eg. Searchable name (lowcase + _)
    kjvObj.book[index].jsFileIdx    eg. Book found in this JS file 
    kjvObj.book[index].verses(ch)   eg, given 1 based chapter - returns verses in ch (0 if JS not loaded) 
*/
var kjvObj = {js:[], book:[]};          

function MkSearchable(text) { //Book searchable strings = trim + lowercase + "1 " -> "1_" and Song_of_Solomon
   var str = text.trim().toLowerCase();
   if (str.startsWith("1 ")) return "1_" + str.substr(2); 
   else if (str.startsWith("2 ")) return "2_" + str.substr(2); 
   else if (str.startsWith("3 ")) return "3_" + str.substr(2);
   else if (str.startsWith("song of s")) return str.replace(" ","_").replace(" ","_"); 
   else if (str.startsWith("song o")) return str.replace(" ","_"); 
   else return str;
} 
function kjvObj_Init() {
  var i;
  
  // JS Files and data
  for (i = 0; i < kjv_JsFiles.length; i++) {
    kjvObj.js[i] = {
      name:  kjv_JsFiles[i][0],
      bkOne: kjv_JsFiles[i][1],
      bkNum: kjv_JsFiles[i][2],
      path:  ("kjv/" +kjv_JsFiles[i][3]),
      jsStaus: 0
    }; 
  }
  
  // Bible books 
  for (i = 0; i < kjv_index.length; i++) {
    kjvObj.book[i] = {
      chapter:   [],                // eg. book[0].chapter[c][v] = bible text array once kjv/kjv_gen.js file loaded
      chapters:  kjv_index[i][4],   // eg. book[0].chapters = 50; Num chapters in the book of genesis 
      name:      kjv_index[i][3],   // eg. book[0].name = "Genesis"
      name3:     kjv_index[i][5],   // eg. book[0].name3 = "Gen"
      name_:     MkSearchable(kjv_index[i][3]),  // Name used for searching eg. "1 Timothy" -> 1_Timothy"  
      jsFileIdx: kjv_index[i][1]    // eg. book[0].jsFileIdx = 0; -- JS file 0 containing this book
    }
    kjvObj.book[i].verses = function(ch) {     // ch is 1 based
       if (ch >= 1 && ch <= this.chapter.length) return this.chapter[ch-1].length; else return 0; }
  }
}
kjvObj_Init();

function findBook_startsWith(text) {  //use MkSearchableStr() before passing a str
   if (!text || text.length == 0) 
     return -1; 
   var i;
   for (i = 0; i < kjvObj.book.length; i++) {
     if (kjvObj.book[i].name_.startsWith(text)) 
       return i;
   }
   return -1;
}
function FindBook(text, ret) {  
//
// Given text like "Ge 1:1" return first match in book list
// ret.index = -1  -- -1 if no match found - otherwise index of book match
// ret.book = full book name
// ret.chapter : ret.verse = target ch:verse requested
//
  
   var k = -1;                      // Default return
   CopyBkRec(null, ret);            // create ret book obj with defaults
   var text = MkSearchable(text);   // lower, trim, "1 xx" to "1_xx"
   var ss = text.split(' ');        // looking for "gen" or "gen 1" or "gen 1:1" pattern - Not "gen 1 nnn"
  
   if (ss.length == 1 || ss.length == 2) {
      k = findBook_startsWith(ss[0]);
      ret["index"] = k;
      if (k >= 0)
        ret["book"] = kjvObj.book[k].name;  // return full bookname
   }

   // get optional secondary ch:verse param - "1" or "1:1" 
   if (k > -1 && ss.length == 2) {
      var cBookChapters = kjvObj.book[k].chapters;
      var nn = ss[1].split(":");
      if (nn.length == 1 || nn.length == 2) {
        var n = parseInt(nn[0]);
        if (!isNaN(n)) {
          if (n > cBookChapters) n = cBookChapters;
          ret["chapter"] = n;
        }
      }   
      if (nn.length == 2) {
        var n = parseInt(nn[1]);
        if (!isNaN(n))
          ret["verse"] = n;
      } 
   }
   return k;
}
function CopyBkRec(bk, ret) {  // bk --> ret | if bk=null just init ret with default book properties
   if (bk === ret)
     return;
   ret.index = -1;     //func returns book index -- ZERO based
   ret.book = "";      //full book name 
   ret.chapter = 1;    // ONE based 
   ret.verse = 1;      // ONE based
   if (bk && bk.index >= 0) {
     ret.index = bk.index;
     ret.book = bk.book;
     ret.chapter = bk.chapter;
     ret.verse = bk.verse;
   }  
}

function Test_kjvBookLoaded(index) { // Sniff out book loaded in our data store
  var jsIdx = kjvObj.book[index].jsFileIdx;
  return (kjvObj.book[index].chapter.length > 0   // Somthing in that book now
       && kjvObj.js[jsIdx].jsStatus === 3);       // Loaded Done flag is set
}
function Test_kjvBookLoaded2(index) { // Sniff out actual JS data file  
   var kjvIdx = kjvObj.book[index].jsFileIdx; 
   var ok;
   switch(kjvIdx) {  //["kjv_gen", "kjv_jos", "kjv_2ch", "kjv_isa", "kjv_mat", "kjv_rom"];
     case 0: ok = (typeof kjv_gen !== 'undefined'); break; 
     case 1: ok = (typeof kjv_jos !== 'undefined'); break;
     case 2: ok = (typeof kjv_2ch !== 'undefined'); break;
     case 3: ok = (typeof kjv_isa !== 'undefined'); break;
     case 4: ok = (typeof kjv_mat !== 'undefined'); break;
     case 5: ok = (typeof kjv_rom !== 'undefined'); break;
   default: ok = false;
   }
   return ok;
}
function DelayLoadJSFile(bkIndex) {  // book index -- Return TRUE if already loaded and ready to go
//
// JIT - load 6x JS Bble files when required
// <script type="text/javascript" src="kjv/kjv_gen.js"></script> 
//  
  var jsIdx  = kjvObj.book[bkIndex].jsFileIdx;
  
  var status = kjvObj.js[jsIdx].jsStatus; 
  var bkOne  = kjvObj.js[jsIdx].bkOne; 
  var bkNum  = kjvObj.js[jsIdx].bkNum; 

  // already loaded OK (3) - ready to use!!
  if (status === 3) {
    return true;
  }
  
  // already loading (1) 
  if (status === 1) {
    return false; 
  }

  kjvObj.js[jsIdx].jsStatus = 1; // LOADING

  //==== START_SCRIPT
  var script1 = document.createElement("script");
  script1.type = "text/javascript";
  script1.src = kjvObj.js[jsIdx].path;
  document.head.appendChild(script1);   //was .body.
  //==== END_SCRIPT

  // Error -> onerror event = Missing file? 
  script1.onerror = function() 
  { 
    kjvObj.js[jsIdx].jsStatus = 2; // FAIL
    
    alert("Error loading bible data file: " + this.src +"\nTry downloading the latest '/kjv' folder."); 
  };
  
  // Success -> an OnLoad event
  script1.onload = function() 
  { 
    kjvObj.js[jsIdx].jsStatus = 3; // OK
    
    // Data File Accuracy test
    var ok;
    try {
      switch(jsIdx) {  
        case 0: ok = (kjv_gen.length == bkNum && kjvObj.book[bkOne].name_ == "genesis"); break;  
        case 1: ok = (kjv_jos.length == bkNum && kjvObj.book[bkOne].name_ == "joshua"); break; 
        case 2: ok = (kjv_2ch.length == bkNum && kjvObj.book[bkOne].name_ == "2_chronicles"); break; 
        case 3: ok = (kjv_isa.length == bkNum && kjvObj.book[bkOne].name_ == "isaiah"); break; 
        case 4: ok = (kjv_mat.length == bkNum && kjvObj.book[bkOne].name_ == "matthew"); break; 
        case 5: ok = (kjv_rom.length == bkNum && kjvObj.book[bkOne].name_ == "romans"); break; 
        default: ok = false;
      }
    } catch (e) { ok = false; }
    if (!ok) alert('bible_data_check_error_210 \n\nTry downloading the latest /kjv/ folder.');
 
    // Assign by Ref into JS data (not a coppy)
    var i;  
    switch(jsIdx) {  
      case 0: for (i = 0; i < bkNum; i++) kjvObj.book[bkOne+i].chapter = kjv_gen[i]; break;
      case 1: for (i = 0; i < bkNum; i++) kjvObj.book[bkOne+i].chapter = kjv_jos[i]; break;
      case 2: for (i = 0; i < bkNum; i++) kjvObj.book[bkOne+i].chapter = kjv_2ch[i]; break;
      case 3: for (i = 0; i < bkNum; i++) kjvObj.book[bkOne+i].chapter = kjv_isa[i]; break;
      case 4: for (i = 0; i < bkNum; i++) kjvObj.book[bkOne+i].chapter = kjv_mat[i]; break;
      case 5: for (i = 0; i < bkNum; i++) kjvObj.book[bkOne+i].chapter = kjv_rom[i]; break;
      default: alert('out_of_range_error_110');
    }

    //test data is by reference not coppied
    /*
    //kjv_gen[0][0][0] = "Original Verse 0,0,0 modified";
    alert("js.length=*" + kjvObj.js.length +"*\r"
         +"jsIdx    =*" + jsIdx +"*\r"
         +"js[j].name=*" + kjvObj.js[jsIdx].name +"*\r"
         +"js[j].path=*" + kjvObj.js[jsIdx].path +"*\r"
         +"js[j].jsStatus=*" + kjvObj.js[jsIdx].jsStatus +"*\r"
         +"Book name = *" + kjvObj.book[bkIndex].name  +"*\r"
      //   +"JS[0] verse 1:1 = *" + kjv_gen[0][0][0]  +"*\r"
      //   +"Book[0] verse 1:1 = *" + kjvObj.book[0].chapter[0][0]  +"*\r"
      //   +"Book[] verse 1:1 = " + kjvObj.book[bkIndex].chapter[0][0]
         );  
    */
 
  };
  return false;
}

//============ Display Data
/*
var html = [];
html.push(
  "<html>",
  "<body>",
  "bla bla bla",
  "</body>",
  "</html>"
);
return html.join("");

var fruits = ["Banana", "Orange", "Apple", "Mango"];
var energy = fruits.join(" and ");

var hege = ["Cecilie", "Lone"];
var stale = ["Emil", "Tobias", "Linus"];
var kai = ["Robin"];
return = hege.concat(stale, kai);

var fruits = ["Banana", "Orange", "Apple", "Mango"];
fruits.push("Kiwi");

array.push(item1, item2, ..., itemX)
*/

function ChapterVerses(bkIdx, chapter) { 
  if (bkIdx >= 0) return kjvObj.book[bkIdx].verses(chapter); else return 0;
}
function CV_IsLastVerses(bkIdx, chapter, verse) { //check if verse near end of list (so we don't scroll adjust)
  return ((kjvObj.book[bkIdx].chapters == chapter)
       && (kjvObj.book[bkIdx].chapter[chapter-1].length <= verse+4)); 
}

function MakeCHID(chapter) {
  return "chID_"+chapter;  //eg. chID_n
}
function MakeCVID(chapter, verse) {
  return "cvID_"+chapter+"_"+verse;  //eg. cvID_1_1
}

function CV_ScrollTo(bk, sticky_height) {  //scroll to selected C:V
  var sID;
  var ChHdr = _metadata.settings[_md.ChHdr].checked;
  if (ChHdr && bk.verse < 6)           // include book title if we can
     sID = MakeCHID(bk.chapter);
  else
     sID = MakeCVID(bk.chapter, bk.verse);
  var el = document.getElementById(sID);
  if (el) {
    el.scrollIntoView(); 
    if (bk.chapter == 1 && bk.verse < 6) {
      document.body.scrollTop = sticky_height;
      document.documentElement.scrollTop = sticky_height;
    }
    else {
      if (!CV_IsLastVerses(bk.index, bk.chapter, bk.verse)) {
        document.body.scrollTop += -134; //safari
        document.documentElement.scrollTop += -134; //other browsers
      }
    }

  } //else alert("ID not found :"+sID);
} 

function BibleVerseSubs(str) { 
  //Underline LORD, GOD, God 410
  var str = str.replace(/[L][O][R][D]\W?[H]\d\d*/g, 
    function(x) {return '<span style="color:red;border-bottom:1px dashed darkred">'+x.substr(0,4)+'</span>'+x.substr(4);});  
  var str = str.replace(/[G][O][D]\W?[H]\d\d*/g, 
    function(x) {return '<span style="color:red;border-bottom:1px dashed darkred">'+x.substr(0,3)+'</span>'+x.substr(3);});  
  var str = str.replace(/[G][o][d]\W?[H][4][1][0]/gi, 
    function(x) {return '<span style="color:red;border-bottom:1px dashed darkred">'+x.substr(0,3)+'</span>'+x.substr(3);});  
 
  //may have 0 or 1 non-word char inbetween God and H430
  var str = str.replace(/[G][o][d]\W?[H][4][3][0]/gi, 
    function (x) {return '<span style="color:blue;border-bottom:1px dashed blue">Elohim</span>'+x.substr(3);});
  return str;
}

//Moved to Tools.html
//function ShowStrongNum(el) {
//   alert("show Strong Number Info = "+el.innerHTML);
//}

function StyleAllStrongNums(str) { 
  // Deal with Backets (H2000) and (H2000 H300)
  var str = str.replace(/[(][H]\d\d*/g, function (Hnn) {
    return '<span class="myStrongsSup">(</span>'+Hnn.substr(1, Hnn.length-1);
  });
  var str = str.replace(/[H]\d\d*[)]/g, function (Hnn) {
    return Hnn.substr(0, Hnn.length-1)+'<span class="myStrongsSup">)</span>';
  });
  
  var str = str.replace(/[(][G]\d\d*/g, function (Hnn) {
    return '<span class="myStrongsSup">(</span>'+Hnn.substr(1, Hnn.length-1);
  });
  var str = str.replace(/[G]\d\d*[)]/g, function (Hnn) {
    return Hnn.substr(0, Hnn.length-1)+'<span class="myStrongsSup">)</span>';
  });

  // Now we can deal with H2000 Link 
  var str = str.replace(/[H]\d\d*/g, function (Hnn) {
    return '<span class="myStrongsSup" onclick="ShowStrongNum(this);">'+Hnn+'</span>';
  });
  var str = str.replace(/[G]\d\d*/g, function (Hnn) {
    return '<span class="myStrongsSup" onclick="ShowStrongNum(this);">'+Hnn+'</span>';
  });
  return str;
}

var StrongsVisible = true;

function ShowStrongs(fValue) {
  var i, elements = document.getElementsByClassName("myStrongsSup");
  for (var i = 0; i < elements.length; i++){
    if (fValue) elements[i].style.display = "inline-block";
    else elements[i].style.display = "none";
  } 
}

function greenLinkClick(el, cvStr) {
    // Toggle current & store
    StrongsVisible = !StrongsVisible;
    _metadata.StrongsVisible(StrongsVisible);
  
    //showHide - keeping scroll position
    var elPos = el.getBoundingClientRect().top;
    ShowStrongs(StrongsVisible);
    var elOffset = elPos - el.getBoundingClientRect().top;
    window.scrollBy(0, -elOffset); 
  
    //Update cc:vv display and _currentBook
    var ss = cvStr.split(/\D+/);  // "Gen 1:22" -> ",1,22"
    if (ss.length === 3) {
      //alert(parseInt(ss[1]) +","+ parseInt(ss[2]));
      UpdateChVsDisplay(parseInt(ss[1]), parseInt(ss[2]));
    }
}

function FormatVerse(html, str, newPara, brLineIndent) {
   // Markup showing?
   if (_metadata.settings[_md.Markup].checked)
     var str = BibleVerseSubs(str); 
  
   var n = str.indexOf("|");          // "Gen 1:2|verse text..."
  
   var cvStr = str.substr(0, n);  // just "Gen 1:2"
   if (brLineIndent) {

      html.push('<span onclick="greenLinkClick(this,\''+cvStr+'\');" class="verseNumberIndentSup">' ,
                  cvStr.split(":")[1], // "2 of Gen 1:2"
               '</span>&nbsp;');      
   }
   else {
     if (newPara)
       html.push('<span onclick="greenLinkClick(this,\''+cvStr+'\');" class="verseNumberGreen">' ,
                  cvStr, // "Gen 1:2"
               '</span>&nbsp;&nbsp;');  
     else
        html.push('&nbsp;<span onclick="greenLinkClick(this,\''+cvStr+'\');" class="verseNumberSup">' ,
                  cvStr.split(":")[1], // "2 of Gen 1:2"
               '</span>'); 
   }
  
   // Verse Text
   html.push(StyleAllStrongNums(str.substr(n+1)));
}

function HideShowCh(book_chapter_ID) {
   var el = document.getElementById(book_chapter_ID);
   //alert(el);
   if (el.style.display == "none") 
     el.style.display = "block"; else el.style.display = "none"; 
}
function ExpandContractChapters(event) {
  event.stopPropagation();
  var i, eClose=false, elements = document.getElementsByClassName("ChapterContentDiv");
  for (var i = 0; i < elements.length; i++){
    if (elements[i].style.display === "none") {
      eClose = true;
      break;
    }
  }  
  // Toggle ALL to the oposite state
  for (var i = 0; i < elements.length; i++){
    if (eClose) elements[i].style.display = "block";
    else elements[i].style.display = "none";
  }  
}
function FormatBibleText(bk, div) {
  var ChHdr = _metadata.settings[_md.ChHdr].checked;         // Show Ch Headings -- and thus Expando
  var TopicHdr = _metadata.settings[_md.TopicHdr].checked;   // Show Topic Headings (embedded in verse)
  
  var html = [''];
  var i, n, cvID, chID;

  var bkIdx = bk.index;
  var verseObj = [], sVerse, sTopic;              // most verses are single string -- some are str array Obj [topicHdr, Verse]
  var redInfo = null;  //null of array
  var pp = null, ppOK = false, newPara, brLineIndent = false, vsTotal;
  var debugMode = _metadata.debugMode;

  //Set global
  StrongsVisible = _metadata.StrongsVisible(); 
        
  // == Chapters ==
  for (i = 0; i < kjvObj.book[bkIdx].chapter.length; i++) {
    
    // Chapter Heading -- Clickable
    if (ChHdr) {
      chID = MakeCHID(i+1); // chID_n
      html.push('<div id="'+chID+'" class="ChapterTitle" onclick="HideShowCh(\'book_chapter_'+i+'\');">' 
              +bk.book+ ' '+(i+1)+'<span title="Expand All" class="ChapterTitleIcon" onclick="ExpandContractChapters(event);">+</span></div>');
    }
     
    // if current chapt OE Expand is OFF --> Show Block
    if (i == bk.chapter-1 || !ChHdr) 
      html.push('<div id="book_chapter_'+i+'" class="ChapterContentDiv">');
    else 
      html.push('<div id="book_chapter_'+i+'" class="ChapterContentDiv" style="display:none;">');

    // Chapter paragraphs ON?
    vsTotal = kjvObj.book[bkIdx].chapter[i].length;
    if (_metadata.settings[_md.ParaOn].checked) {
      pp = GetCVParas(bkIdx, i, vsTotal);
      ppOK = ValidateCVParas(pp, bkIdx, i);
      brLineIndent = false;
    }
    
    // == Verses ==
    for (n = 0; n < vsTotal; n++) {
      cvID = MakeCVID(i+1, n+1);
      verseObj = kjvObj.book[bkIdx].chapter[i][n];
      
      // Verse obj ["TopicHrd", VerseStr] OR "VerseStr"
      if (typeof verseObj == "object" && verseObj.length >= 2) 
           { sVerse = verseObj[1]; sTopic = verseObj[0]; }
      else { sVerse = verseObj;    sTopic = ""; }
      
      // 2 = (para of 1); 1,3 (para of 2); 1,0,3 (pagraph of 3); 1,-1,3 (indent lines 3)
      //
      newPara = (!ppOK || pp[n] == 1 || pp[n] ==2);
      if (newPara) {
        // debug
        if (debugMode && n==0) {
          html.push('<div style="padding:12px;background-color:#655;color:white;font-size:14px;overflow:scroll;">');  
          html.push('Debug: ch='+(i+1)+', vs='+(n+1)+', pp=['+_paragraphs[bkIdx][i]+']<br>'); 
          html.push('Expanded pp=['+pp+']'); 
          html.push('</div>');
        }
        
        //new paragraph wrap
        html.push('<p>');  //new paragraph wrap
        brLineIndent = (ppOK && pp[n] == 1 && (n+1 < vsTotal) && pp[n+1] == -1)  //read ahead = for -1 line break code
      }
            
      //topic header
      if (TopicHdr && sTopic.length)
        html.push('<div style="margin-bottom:12px;padding:6px 8px; font-size:120%;xfont-weight:bold;color:#222;background-color:lightgreen;">' 
            +sTopic+ '</div>');
      
      //write Study note
      var note = _study.GetNote(bkIdx,i+1,n+1);
      if (note.length != 0)
        html.push(note.join(" "));

      // first Paragraph of chapter
      if (n == 0 && newPara && brLineIndent)
         html.push('<div class="verseNumberGreen2" onclick="greenLinkClick(this,\''+sVerse.split("|")[0]+'\');">',
                  sVerse.split("|")[0], // "Gen 1:2"
                  '</div>');
      
      // Verse wrap
      if (brLineIndent)
        html.push('<span id="'+cvID+'" style="margin-left:44px;display:block;text-indent: -16px;">'); 
      else 
        html.push('<span id="'+cvID+'">');       //verse text wrap 
      
      // Verse String
      FormatVerse(html, sVerse, newPara, brLineIndent);   
      
      html.push('</span>');                   //end verse text wrap 
      if (!ppOK || pp[n] == 2 || pp[n] ==3)   //end verse para wrap
        html.push('</p>'); 
    }
    html.push('</div>');
  }
  html.push('<br>');
  div.innerHTML = html.join('');
  
  if (!StrongsVisible)
    ShowStrongs(false);
}

/*

function ESwordFormat(str) { 
  //eSword puts puntuation before number
  var str = str.replace(/[H]\d\d*[.]/g, function (Hnn) {return Hnn.substr(Hnn.length-1)+Hnn.substr(0, Hnn.length-1); });
  var str = str.replace(/[H]\d\d*[,]/g, function (Hnn) {return Hnn.substr(Hnn.length-1)+Hnn.substr(0, Hnn.length-1); });

  var str = str.replace(/[G]\d\d*[.]/g, function (Hnn) {return Hnn.substr(Hnn.length-1)+Hnn.substr(0, Hnn.length-1); });
  var str = str.replace(/[G]\d\d*[,]/g, function (Hnn) {return Hnn.substr(Hnn.length-1)+Hnn.substr(0, Hnn.length-1); });
  
  var str = str.replace(/[(][H]\d\d*[)][.]/g, function (Hnn) {return Hnn.substr(Hnn.length-1)+Hnn.substr(0, Hnn.length-1); });
  var str = str.replace(/[(][H]\d\d*[)][,]/g, function (Hnn) {return Hnn.substr(Hnn.length-1)+Hnn.substr(0, Hnn.length-1); });

  var str = str.replace(/[(][G]\d\d*[)][.]/g, function (Hnn) {return Hnn.substr(Hnn.length-1)+Hnn.substr(0, Hnn.length-1); });
  var str = str.replace(/[(][G]\d\d*[)][,]/g, function (Hnn) {return Hnn.substr(Hnn.length-1)+Hnn.substr(0, Hnn.length-1); });

  
  var str = str.replace(/[H]\d\d*[:]/g, function (Hnn) {return Hnn.substr(Hnn.length-1)+Hnn.substr(0, Hnn.length-1); });
  var str = str.replace(/[H]\d\d*[;]/g, function (Hnn) {return Hnn.substr(Hnn.length-1)+Hnn.substr(0, Hnn.length-1); });

  var str = str.replace(/[G]\d\d*[:]/g, function (Hnn) {return Hnn.substr(Hnn.length-1)+Hnn.substr(0, Hnn.length-1); });
  var str = str.replace(/[G]\d\d*[;]/g, function (Hnn) {return Hnn.substr(Hnn.length-1)+Hnn.substr(0, Hnn.length-1); });
  
  var str = str.replace(/[(][H]\d\d*[)][:]/g, function (Hnn) {return Hnn.substr(Hnn.length-1)+Hnn.substr(0, Hnn.length-1); });
  var str = str.replace(/[(][H]\d\d*[)][;]/g, function (Hnn) {return Hnn.substr(Hnn.length-1)+Hnn.substr(0, Hnn.length-1); });

  var str = str.replace(/[(][G]\d\d*[)][:]/g, function (Hnn) {return Hnn.substr(Hnn.length-1)+Hnn.substr(0, Hnn.length-1); });
  var str = str.replace(/[(][G]\d\d*[)][;]/g, function (Hnn) {return Hnn.substr(Hnn.length-1)+Hnn.substr(0, Hnn.length-1); });
  
  return str;
}

function FormatBibleText__(bk, div) {
  var html = [''];
  var i, n, cvID, bkIdx = bk.index;
  for (i = 0; i < kjvObj.book[bkIdx].chapter.length; i++) {
    for (n = 0; n < kjvObj.book[bkIdx].chapter[i].length; n++) {
      cvID = MakeCVID(i+1, n+1);
      //html.push('<p id='+cvID+'>');
      html.push(ESwordFormat( kjvObj.book[bkIdx].chapter[i][n] ), '<br>');
      //html.push('</p>'); 
    }
    //html.push('<br>');
  }
  html.push('<br>');
  div.innerHTML = html.join('');
}

*/





